# This is a BitKeeper generated patch for the following project:
# Project Name: Linux kernel tree
# This patch format is intended for GNU patch command version 2.5 or higher.
# This patch includes the following deltas:
#	           ChangeSet	1.1069.1.246+1.1069.316.1 -> 1.1069.1.247
#	include/asm-i386/mpspec.h	1.9.1.2 -> 1.11.1.1
#	arch/i386/kernel/mpparse.c	1.27.1.20 -> 1.30.1.12
#	drivers/acpi/system.c	1.17.1.4 -> 1.17.1.5
#	arch/i386/kernel/setup.c	1.68.1.15 -> 1.70.1.11
#	arch/ia64/kernel/acpi.c	1.6.3.18 -> 1.6.4.7
#	  drivers/acpi/bus.c	1.18.1.5 -> 1.22   
#	Documentation/Configure.help	1.162.1.73 -> 1.166.1.37
#
diff -Nru a/Documentation/Configure.help b/Documentation/Configure.help
--- a/Documentation/Configure.help	Tue Mar 23 14:55:16 2004
+++ b/Documentation/Configure.help	Tue Mar 23 14:55:16 2004
@@ -18601,6 +18601,11 @@
   purpose port, say Y here. See
   <http://www.dig64.org/specifications/DIG64_HCDPv10a_01.pdf>.
 
+Support for serial ports defined in ACPI namespace
+CONFIG_SERIAL_ACPI
+  If you wish to enable serial port discovery via the ACPI
+  namespace, say Y here.  If unsure, say N.
+
 Support for PowerMac serial ports
 CONFIG_MAC_SERIAL
   If you have Macintosh style serial ports (8 pin mini-DIN), say Y
diff -Nru a/drivers/acpi/bus.c b/drivers/acpi/bus.c
--- a/drivers/acpi/bus.c	Tue Mar 23 14:55:16 2004
+++ b/drivers/acpi/bus.c	Tue Mar 23 14:55:16 2004
@@ -1405,16 +1405,14 @@
 	switch (type) {
 	case ACPI_BUS_TYPE_DEVICE:
 		result = acpi_bus_get_status(device);
-		if (result)
-			goto end;
-		break;
+		if (!result)
+			break;
+		if (!device->status.present)
+			result = -ENOENT;
+		goto end;
 	default:
 		STRUCT_TO_INT(device->status) = 0x0F;
 		break;
-	}
-	if (!device->status.present) {
-		result = -ENOENT;
-		goto end;
 	}
 
 	/*
